<?php
/*
  $Id: nb_reviews.php
  $Loc: catalog/includes/modules/navbar_modules/

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com 

  2017 Navbar Modules 1.0 BS 
  by @raiwa 
  info@sarplataygemas.com
  www.oscaddons.com

  Copyright (c) 2016 osCommerce

  Released under the GNU General Public License
*/

  class nb_reviews {
    var $code = 'nb_reviews';
    var $group = 'navbar_modules_home';
    var $title;
    var $description;
    var $sort_order;
    var $enabled = false;    
    
    function __construct() {
      $this->title = MODULE_NAVBAR_REVIEWS_TITLE;
      $this->description = '<div class="secWarning"><a target="_blank" href="http://www.oscaddons.com/en/commercial-add-ons/navbar-header-modules-p-54.html">GET ALL NAVBAR AND HEADER MODULES AT OSCADDONS.COM</a><br>
                            - Navbar and Header Modules to replace all side column boxes
                            </div>';
      $this->description .= MODULE_NAVBAR_REVIEWS_DESCRIPTION;

      if ( defined('MODULE_NAVBAR_REVIEWS_STATUS') ) {
        $this->sort_order = MODULE_NAVBAR_REVIEWS_SORT_ORDER;
        $this->enabled = (MODULE_NAVBAR_REVIEWS_STATUS == 'True');
        
        switch (MODULE_NAVBAR_REVIEWS_CONTENT_PLACEMENT) {
          case 'Home':
          $this->group = 'navbar_modules_home';
          break;
          case 'Left':
          $this->group = 'navbar_modules_left';
          break;
          case 'Right':
          $this->group = 'navbar_modules_right';
          break;
        } 
      }
    }

    function getOutput() {
      global $oscTemplate, $languages_id;
      
      $random_select = "select r.reviews_id, r.reviews_rating, substring(rd.reviews_text, 1, " . MODULE_NAVBAR_REVIEWS_LENGTH . ") as reviews_text, p.products_id, p.products_image, pd.products_name from reviews r, reviews_description rd, products p, products_description pd where p.products_status = '1' and p.products_id = r.products_id and r.reviews_id = rd.reviews_id and rd.languages_id = '" . (int)$languages_id . "' and p.products_id = pd.products_id and pd.language_id = '" . (int)$languages_id . "' and r.reviews_status = 1";
      if (isset($_GET['products_id'])) {
        $random_select .= " and p.products_id = '" . (int)$_GET['products_id'] . "'";
      }
      $random_select .= " order by rand() limit " . MODULE_NAVBAR_REVIEWS_CONTENT_LIMIT;
      $random_query = tep_db_query($random_select);
      $num_reviews = tep_db_num_rows($random_query);

      $linkArray[] = '<li><a href="' . tep_href_link('reviews.php') . '">' .  MODULE_NAVBAR_REVIEWS_MODULE_VIEW_ALL . '</a>';
      $linkArray[] .= '<li role="separator" class="divider"></li>';

      if ($num_reviews) {
// display random review menu
			  while ($products = tep_db_fetch_array($random_query)) {
          $linkArray[] = '<li><a href="' . tep_href_link('product_reviews.php', 'products_id=' . $products['products_id']) .'">';
				  $linkArray[] .= tep_image ('images/' . $products['products_image'], NULL, '40', '40', null, false);
				  $linkArray[] .= '&nbsp;' . $products['reviews_text'] . '...&nbsp;';
				  $linkArray[] .= tep_draw_stars($products['reviews_rating']);


          
          $linkArray[] .= '</a></li>';
        }
      } elseif (isset($_GET['products_id'])) {
// display 'write a review' menu
        $linkArray[] .= '<li><a href="' . tep_href_link('product_reviews_write.php', 'products_id=' . $_GET['products_id']) . '">' . MODULE_NAVBAR_REVIEWS_WRITE_REVIEW .'</a></li>';
      } else {
// display 'no reviews' menu
        $linkArray[] .= '<li style="padding: 10px;">' . MODULE_NAVBAR_REVIEWS_NO_REVIEWS . '</li>';
      }
      
      
      $reviews_menu_contents = '<li class="dropdown">
        		 											 <a class="dropdown-toggle" data-toggle="dropdown" href="#"><i class="fa fa-comment"></i><span class="hidden-sm"> ' .  MODULE_NAVBAR_REVIEWS_PUBLIC_TEXT . '</span> <i class="fa fa-caret-down"></i></a> 
        		 											 <ul class="dropdown-menu" style="min-width:100%;">';
      foreach ($linkArray as $link) {
        $reviews_menu_contents .=    $link;
      }
      
      $reviews_menu_contents .= '  </ul>
        												 </li>';


      ob_start();
      require('includes/modules/navbar_modules/templates/reviews.php');
      $data = ob_get_clean();

      $oscTemplate->addBlock($data, $this->group);
    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_NAVBAR_REVIEWS_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Reviews Module', 'MODULE_NAVBAR_REVIEWS_STATUS', 'True', 'Do you want to add the module to your Navbar?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Placement', 'MODULE_NAVBAR_REVIEWS_CONTENT_PLACEMENT', 'Left', 'Should the module be loaded in the Left or Right or the Home area of the Navbar?', '6', '2', 'tep_cfg_select_option(array(\'Left\', \'Right\', \'Home\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_NAVBAR_REVIEWS_SORT_ORDER', '535', 'Sort order of display. Lowest is displayed first.', '6', '3', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Number of Reviews', 'MODULE_NAVBAR_REVIEWS_CONTENT_LIMIT', '6', 'How many reviews should be shown in the drop down menu? Zero disables the menu.', '6', '4', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Text length', 'MODULE_NAVBAR_REVIEWS_LENGTH', '35', 'Length of the review text (characters).', '6', '5', now())");
    }

    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_NAVBAR_REVIEWS_STATUS', 'MODULE_NAVBAR_REVIEWS_CONTENT_PLACEMENT', 'MODULE_NAVBAR_REVIEWS_SORT_ORDER', 'MODULE_NAVBAR_REVIEWS_CONTENT_LIMIT', 'MODULE_NAVBAR_REVIEWS_LENGTH');
    }
  }
  