<?php
/*
  $Id: cm_header_reviews.php
  $Loc: catalog/includes/modules/content/header/

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Header Modules 2.0 Phoenix
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2019 Rainer Schmied

  Released under the GNU General Public License
*/

  class cm_header_reviews {
    var $code;
    var $group;
    var $title;
    var $description;
    var $sort_order;
    var $m_align = null;
    var $enabled = false;

    function __construct() {
      $this->code = get_class($this);
      $this->group = basename(dirname(__FILE__));

      $this->title = MODULE_CONTENT_HEADER_REVIEWS_TITLE;
      $this->description = '<div class="secWarning"><a target="_blank" href="http://www.oscaddons.com/en/commercial-add-ons/navbar-header-modules-p-54.html">GET ALL NAVBAR AND HEADER MODULES AT OSCADDONS.COM</a><br>
                            - Navbar and Header Modules to replace all side column boxes
                            </div>';
      $this->description .= MODULE_CONTENT_HEADER_REVIEWS_DESCRIPTION;

      if ( defined('MODULE_CONTENT_HEADER_REVIEWS_STATUS') ) {
        $this->sort_order = MODULE_CONTENT_HEADER_REVIEWS_SORT_ORDER;
        $this->enabled = (MODULE_CONTENT_HEADER_REVIEWS_STATUS == 'True');
        if (MODULE_CONTENT_HEADER_REVIEWS_DROPDOWN_ALIGN == 'Right') $this->m_align = ' dropdown-menu-right';
      }
    }

    function execute() {
      global $oscTemplate, $customer_id, $languages_id, $request_type;

      $menu_align = $this->m_align;
      $content_width = (int)MODULE_CONTENT_HEADER_REVIEWS_CONTENT_WIDTH;

      $allow_reviews = true;

      if (ALLOW_ALL_REVIEWS == 'false' && tep_session_is_registered('customer_id')) {
        $purchased = array();
        $purchased_products_array = tep_db_query("select distinct op.products_id from orders o, orders_products op where o.customers_id = '" . (int)$customer_id . "' and o.orders_id = op.orders_id group by products_id");
        while ($purchased_products = tep_db_fetch_array($purchased_products_array)) {
          $purchased[] = $purchased_products['products_id'];
        }
        if (!in_array((int)$_GET['products_id'], $purchased)) $allow_reviews = false;
      }

      $random_select = "select r.reviews_id, r.products_id, r.reviews_rating, substring(rd.reviews_text, 1, " . MODULE_CONTENT_HEADER_REVIEWS_LENGTH . ") as reviews_text, p.products_id, p.products_image, pd.products_name from reviews r, reviews_description rd, products p, products_description pd where p.products_status = '1' and p.products_id = r.products_id and r.reviews_id = rd.reviews_id and rd.languages_id = '" . (int)$languages_id . "' and p.products_id = pd.products_id and pd.language_id = '" . (int)$languages_id . "' and r.reviews_status = 1";
      if ( MODULE_CONTENT_HEADER_REVIEWS_PRODUCT_FILTER == 'True' && isset($_GET['products_id'])) {
        $random_select .= " and p.products_id = '" . (int)$_GET['products_id'] . "'";
      }
      $random_select .= " order by rand() limit " . MODULE_CONTENT_HEADER_REVIEWS_CONTENT_LIMIT;
      $random_query = tep_db_query($random_select);
      $num_reviews = tep_db_num_rows($random_query);

      ob_start();
        include('includes/modules/content/' . $this->group . '/templates/tpl_' . basename(__FILE__));
      $template = ob_get_clean();

      $oscTemplate->addContent($template, $this->group);

    }

    function isEnabled() {
      return $this->enabled;
    }

    function check() {
      return defined('MODULE_CONTENT_HEADER_REVIEWS_STATUS');
    }

    function install() {
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Current Version', 'MODULE_CONTENT_HEADER_REVIEWS_VERSION_INSTALLED', '2.0 Phoenix', 'Version info. It is read only.', '6', '1', 'tep_version_readonly(', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Reviews Header menu', 'MODULE_CONTENT_HEADER_REVIEWS_STATUS', 'True', 'Should the Reviews menu and be shown in the header area?', '6', '2', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Content Width', 'MODULE_CONTENT_HEADER_REVIEWS_CONTENT_WIDTH', '3', 'What width container should the content be shown in?', '6', '3', 'tep_cfg_select_option(array(\'12\', \'11\', \'10\', \'9\', \'8\', \'7\', \'6\', \'5\', \'4\', \'3\', \'2\', \'1\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Dropdown align', 'MODULE_CONTENT_HEADER_REVIEWS_DROPDOWN_ALIGN', 'Left', 'How should the dropdown menu content be aligned relative to the menu button.', '6', '1', 'tep_cfg_select_option(array(\'Left\', \'Right\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_CONTENT_HEADER_REVIEWS_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '4', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Number of Reviews', 'MODULE_CONTENT_HEADER_REVIEWS_CONTENT_LIMIT', '6', 'How many reviews should be shown in the drop down menu? Zero disables the menu.', '6', '6', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Text length', 'MODULE_CONTENT_HEADER_REVIEWS_LENGTH', '35', 'Length of the review text (characters).', '6', '6', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Product filter', 'MODULE_CONTENT_HEADER_REVIEWS_PRODUCT_FILTER', 'True', 'Do you want to show only reviews for the actual product if on the product page?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Show images', 'MODULE_CONTENT_HEADER_REVIEWS_IMAGE', 'True', 'Do you want to show the product images?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
    }

    function remove() {
      tep_db_query("delete from configuration where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_CONTENT_HEADER_REVIEWS_VERSION_INSTALLED',
                   'MODULE_CONTENT_HEADER_REVIEWS_STATUS',
                   'MODULE_CONTENT_HEADER_REVIEWS_CONTENT_WIDTH',
                   'MODULE_CONTENT_HEADER_REVIEWS_DROPDOWN_ALIGN',
                   'MODULE_CONTENT_HEADER_REVIEWS_SORT_ORDER',
                   'MODULE_CONTENT_HEADER_REVIEWS_CONTENT_LIMIT',
                   'MODULE_CONTENT_HEADER_REVIEWS_LENGTH',
                   'MODULE_CONTENT_HEADER_REVIEWS_PRODUCT_FILTER',
                   'MODULE_CONTENT_HEADER_REVIEWS_IMAGE');
    }

  }  // End class

// function show the version read only
  if(!function_exists('tep_version_readonly')) {
  	function tep_version_readonly($value){
  		$version_text = '<br>Version ' . $value;
      return $version_text;
    }
  }

