<?php
/*
  $Id: nb_reviews.php
  $Loc: catalog/includes/modules/navbar_modules/

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Navbar Modules 3.0 Phoenix
  by @raiwa
  info@oscaddons.com
  www.oscaddons.com

  Copyright (c) 2020 Rainer Schmied

  Released under the GNU General Public License
*/

  class nb_reviews extends abstract_block_module {

    const CONFIG_KEY_BASE = 'MODULE_NAVBAR_REVIEWS_';

    function getOutput() {

      $allow_reviews = true;

      if ( ALLOW_ALL_REVIEWS == 'false' && isset($_SESSION['customer_id']) ) {
        $purchased = [];
        $purchased_products_array = tep_db_query("SELECT DISTINCT op.products_id 
                                                  FROM orders o, orders_products op 
                                                  WHERE o.customers_id = '" . (int)$_SESSION['customer_id'] . "' 
                                                  AND o.orders_id = op.orders_id 
                                                  GROUP BY products_id");
                                                  
        while ($purchased_products = tep_db_fetch_array($purchased_products_array)) {
          $purchased[] = $purchased_products['products_id'];
        }
        if ( !isset($_GET['products_id']) || !in_array((int)$_GET['products_id'], $purchased) ) $allow_reviews = false;
      }

      $random_select = "SELECT r.reviews_id, r.products_id, r.reviews_rating, substring(rd.reviews_text, 1, " . MODULE_NAVBAR_REVIEWS_LENGTH . ") AS reviews_text, p.products_id, p.products_image, pd.products_name 
                        FROM reviews r, reviews_description rd, products p, products_description pd 
                        WHERE p.products_status = '1' 
                          AND p.products_id = r.products_id 
                          AND r.reviews_id = rd.reviews_id 
                          AND rd.languages_id = '" . (int)$_SESSION['languages_id'] . "' 
                          AND p.products_id = pd.products_id 
                          AND pd.language_id = '" . (int)$_SESSION['languages_id'] . "' 
                          AND r.reviews_status = 1";

      if ( MODULE_NAVBAR_REVIEWS_PRODUCT_FILTER == 'True' && isset($_GET['products_id'])) {
        $random_select .= " AND p.products_id = '" . (int)$_GET['products_id'] . "'";
      }
      $random_select .= " ORDER BY rand() LIMIT " . MODULE_NAVBAR_REVIEWS_CONTENT_LIMIT;
      $random_query = tep_db_query($random_select);
      $num_reviews = tep_db_num_rows($random_query);

      $tpl_data = [ 'group' => $this->group, 'file' => __FILE__ ];
      include 'includes/modules/block_template.php';
    }

    public function get_parameters() {
      return [
        static::CONFIG_KEY_BASE . 'STATUS' => [
          'title' => 'Enable Reviews Drop Down Module',
          'value' => 'True',
          'desc' => 'Do you want to add the module to your Navbar?',
          'set_func' => "tep_cfg_select_option(['True', 'False'], ",
        ],
        static::CONFIG_KEY_BASE . 'CONTENT_PLACEMENT' => [
          'title' => 'Content Placement Group',
          'value' => 'Left',
          'desc' => 'Where should the module be loaded?  Lowest is loaded first, per Group.',
          'set_func' => "tep_cfg_select_option(['Left', 'Right', 'Home'], ",
        ],
        static::CONFIG_KEY_BASE . 'SORT_ORDER' => [
          'title' => 'Sort Order',
          'value' => '530',
          'desc' => 'Sort order of display. Lowest is displayed first.',
        ],
        static::CONFIG_KEY_BASE . 'CONTENT_LIMIT' => [
          'title' => 'Number of Products',
          'value' => '6',
          'desc' => 'How many Reviews should be shown in the drop down menu? Zero disables the menu.',
        ],
        static::CONFIG_KEY_BASE . 'LENGTH' => [
          'title' => 'Text length',
          'value' => '35',
          'desc' => 'Length of the review text (characters).',
        ],
        static::CONFIG_KEY_BASE . 'PRODUCT_FILTER' => [
          'title' => 'Product filter',
          'value' => 'True',
          'desc' => 'Do you want to show only reviews for the actual product if on the product page?',
          'set_func' => "tep_cfg_select_option(['True', 'False'], ",
        ],
        static::CONFIG_KEY_BASE . 'IMAGE' => [
          'title' => 'Show images',
          'value' => 'True',
          'desc' => 'Do you want to show the product images?',
          'set_func' => "tep_cfg_select_option(['True', 'False'], ",
        ],
      ];
    }

  }
